//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ TK ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// ScintillaTK.h - Tk specific subclass of ScintillaBase
// Copyright 1998-2004 by Neil Hodgson <neilh@scintilla.org>
// The License.txt file describes the conditions under which this software may be
// distributed.
// Copyright (c) 2013 Mentor Graphics Corporation
// The license.terms file describes the conditions under which this software may be distributed.

#ifndef SCINTILLATKWIDGET
#define SCINTILLATKWIDGET

#ifdef __cplusplus
extern "C" {
#endif

#include <tcl.h>
#include <tk.h>

// a simple stack dumper
void _print_trace (bool on=false);
int _x_error_handler(Display *, XErrorEvent *);

typedef struct _ScintillaObject ScintillaObject;

// pick a start value safely above what the scintilla code already uses (see Scintilla.h)
enum {
   SCI_TKMSG_PAINT = 10000,
   SCI_TKMSG_DESTROY,
   SCI_TKMSG_DUMPSTYLES,
   SCI_TKMSG_ANNOTATIONINDENT,
   SCI_TKMSG_ANNOTATIONLENGTH,
   SCI_TKMSG_RESIZE
};

struct _ScintillaObject {
   _ScintillaObject() {
//      printf("HEY -- CTOR of ScintillaObject %p\n",(void *)this);
   }
   ~_ScintillaObject() {
//      printf("HEY -- DTOR of ScintillaObject %p\n",(void *)this);
   }
   Tcl_Interp *interp;
   Tk_Window   tkwin;
   ClientData  client; // this will hold the ref to the parent Tk widget

   // pointer to the platform-specific scintilla editor class object
	void *pscin;

   // this flag indicates if this is the main(client) window
   bool main;
};

// THESE ARE IMPLEMENTED IN ScintillaTK.cxx
ScintillaObject* scintilla_new(Tcl_Interp *, Tk_Window, ClientData);
sptr_t scintilla_send_message(ScintillaObject *sci, unsigned int iMessage, uptr_t wParam, sptr_t lParam);

#ifdef __cplusplus
}
#endif

#endif
